﻿using Archives_Center.Properties;
using System;
using System.IO;
using System.Threading;
using System.Windows.Forms;

namespace Archives_Center
{
    public partial class login : Form
    {
        public login()
        {
            InitializeComponent();
            if (!File.Exists(Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments) + @"\ArchivesCenter\Users.encrypted"))
            {
                if (MessageBox.Show("检测到 Archives Center 在此设备上尚属首次启动，是否立即新建账户？", "Archives Center 首次启动检测", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
                {
                    register register = new register();
                    register.ShowDialog();
                }
            }
        }

        private void toolStripButton1_Click(object sender, EventArgs e)
        {
            register register = new register();
            register.ShowDialog();
        }

        private void toolStripButton3_CheckedChanged(object sender, EventArgs e)
        {
            if (toolStripButton3.Checked != true)
            {
                textBox2.ReadOnly = false;
                textBox2.Text = null;
                textBox1.Text = null;
                textBox2.Focus();
            }
            if (toolStripButton3.Checked == true)
            {
                textBox2.Text = Environment.UserDomainName + @"\" + Environment.UserName;
                textBox1.Text = null;
                textBox2.ReadOnly = true;
                textBox1.Focus();
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            try
            {
                if (textBox1.Text.Length > 0)
                {
                    if (textBox2.Text.Length > 0)
                    {
                        string UserDataCachePath = Path.GetTempPath() + @"ArchivesCenter\UsersData\";
                        string Password = "fbHQb7L9ODdO9pyPB4cDaMtiW7AgYKJLmQb7FewTiJZhyQwzCJucVf4scvQt7R6b";
                        string UserDataPath = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments) + @"\ArchivesCenter\Users.encrypted";
                        SevenZipHelper.ExtractEncryptedArchive(UserDataPath, UserDataCachePath, Password);
                        using (StreamReader reader = new StreamReader(UserDataCachePath + textBox2.Text + @"\password.txt"))
                        {
                            string txtpwd = reader.ReadLine();
                            if (txtpwd == textBox1.Text)
                            {
                                Settings.Default.current_user = textBox2.Text;
                                Settings.Default.Save();
                                if (Directory.Exists(Path.GetTempPath() + @"ArchivesCenter\Data\" + Settings.Default.current_user))
                                {
                                    MessageBox.Show("检测到 Archives Center 上次启动后未正常退出，请在稍后开启的命令行窗口内输入您满意的操作。\n推荐进行的操作和输入的内容如下：\n1.加载上一次正常退出时保存的数据库，输入“A”（推荐）\n2.继续使用未正常退出时使用的数据库，输入“S”", "Archives Center 未正常退出", MessageBoxButtons.OK, MessageBoxIcon.Error);
                                }
                                Form1 form1 = new Form1();
                                form1.Show();
                                this.Hide();
                            }
                            else
                            {
                                MessageBox.Show("用户不存在或密码错误！", "Archives Center 登录 错误", MessageBoxButtons.OK, MessageBoxIcon.Error);
                                Thread.Sleep(1000);
                            }
                        }
                        Directory.Delete(Path.GetTempPath() + @"ArchivesCenter\UsersData\", true);
                    }
                    else
                    {
                        MessageBox.Show("请检查您填入的字段是否完整", "登录 错误", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    }
                }
                else
                {
                    MessageBox.Show("请检查您填入的字段是否完整", "登录 错误", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("用户不存在或密码错误！", "登录 错误", MessageBoxButtons.OK, MessageBoxIcon.Error);
                Directory.Delete(Path.GetTempPath() + @"ArchivesCenter\UsersData\", true);
            }
        }
    }
}
